unit unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, WinSvc;

  function ServiceStartType(const Name: string): string;
  function ServiceStatus(const ServiceName: string):string;
  function ServiceDisplayName(const ServiceName: string): string;
  function ServiceFileName(const Name: string): string;
  function ServiceDescription(const ServiceName: string): string;
  function ServiceGetList(sMachine: string; dwServiceType, dwServiceState: Dword; slServicesList: TStrings; slServicesDisplayerNames:TStrings): boolean;

implementation

//////////////////////////////////////////////////////////////////////////////

// Service function

//////////////////////////////////////////////////////////////////////////////

function ServiceStatus(const ServiceName: string): string;

{

  ָ״̬

}

var

  SCM, SCH: SC_Handle;

  ServiceStates: TServiceStatus;

begin

  Result := '';

  SCM := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);

  if SCM <> 0 then

  begin

  SCH := OpenService(SCM, PChar(ServiceName), SERVICE_QUERY_CONFIG);

  if SCH <> 0 then

  begin

  QueryServiceStatus(SCH, ServiceStates);


  case ServiceStates.dwCurrentState of
  1:Result:='ֹͣ';
  2:Result:='';
  3:Result:='ֹͣ';
  4:Result:='';
  5:Result:='ڼ';
  6:Result:='ͣ';
  7:Result:='ͣ';
  end;
  CloseServiceHandle(SCH);

  end;

  CloseServiceHandle(SCM);

  end;

end;

function ServiceDisplayName(const ServiceName: string): string;

{

  ָʾ

}

var

  SCM, SCH: SC_Handle;

  L: DWORD;

begin

  SCM := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);

  if SCM <> 0 then

  begin

  SCH := OpenService(SCM, PChar(ServiceName), SERVICE_QUERY_CONFIG);

  if SCH <> 0 then

  begin

  GetServiceDisplayName(SCM, PChar(ServiceName), nil, L);

  SetLength(Result, L);

  GetServiceDisplayName(SCM, PChar(ServiceName), PChar(Result), L);

  CloseServiceHandle(SCH);

  end;

  CloseServiceHandle(SCM);

  end;

end;

function ServiceFileName(const Name: string): string;

{

  ָӦĿִļ

}

var

  SCM, SCH: SC_Handle;

  ServiceConfig: PQueryServiceConfig;

  R: DWORD;

begin

  SCM := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);

  if SCM <> 0 then

  begin

  SCH := OpenService(SCM, PChar(Name), SERVICE_QUERY_CONFIG);

  if SCH <> 0 then

  begin

  QueryServiceConfig(SCH, nil, 0, R); // Get Buffer Length

  GetMem(ServiceConfig, R + 1);

  QueryServiceConfig(SCH, ServiceConfig, R + 1, R);

  Result := ServiceConfig.lpBinaryPathName;

  FreeMem(ServiceConfig);

  CloseServiceHandle(SCH);

  end;

  CloseServiceHandle(SCM);

  end;

end;

function QueryServiceConfig2(hService: SC_HANDLE; dwInfoLevel: DWORD;

  lpBuffer: PChar; cbBufSize: DWORD; var pcbBytesNeeded: DWORD): BOOL;

  stdcall; external advapi32 name 'QueryServiceConfig2A';

function ServiceDescription(const ServiceName: string): string;

{

  ָϢ

}

const

  SERVICE_CONFIG_DESCRIPTION = $00000001;

type

  TServiceDescription = packed record

  lpDescription: LPSTR;

  end;

  PServiceDescription = ^TServiceDescription;

var

  SCM, SCH: SC_Handle;

  P: PServiceDescription;

  R: DWORD;

begin

  SCM := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);

  if SCM <> 0 then

  begin

  SCH := OpenService(SCM, PChar(ServiceName), SERVICE_QUERY_CONFIG);

  if SCH <> 0 then

  begin

  QueryServiceConfig2(SCH, SERVICE_CONFIG_DESCRIPTION, nil, 0, R); // Get Buffer Length

  GetMem(P, R + 1);

  QueryServiceConfig2(SCH, SERVICE_CONFIG_DESCRIPTION, PChar(P), R + 1, R);

  Result := P.lpDescription;

  FreeMem(P);

  CloseServiceHandle(SCH);

  end;

  CloseServiceHandle(SCM);

  end;

end;

function ServiceStartType(const Name: string): string;

{

  ָӦ

}

var

  SCM, SCH: SC_Handle;

  ServiceConfig: PQueryServiceConfig;

  R: DWORD;

begin

  Result:='';

  SCM := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);

  if SCM <> 0 then

  begin

  SCH := OpenService(SCM, PChar(Name), SERVICE_QUERY_CONFIG);

  if SCH <> 0 then

  begin

  QueryServiceConfig(SCH, nil, 0, R); // Get Buffer Length

  GetMem(ServiceConfig, R + 1);

  QueryServiceConfig(SCH, ServiceConfig, R + 1, R);

  case ServiceConfig.dwStartType of
  1:Result:='ϵͳ';
  2:Result:='Զ';
  3:Result:='ֶ';
  4:Result:='ѽֹ';
  end;

  FreeMem(ServiceConfig);

  CloseServiceHandle(SCH);

  end;

  CloseServiceHandle(SCM);

  end;

end;

function ServiceGetList(sMachine: string; dwServiceType, dwServiceState: Dword;
  slServicesList: TStrings; slServicesDisplayerNames:TStrings): boolean;
const
  //
  // assume that the total number of
  // services is less than 4096.
  // increase if necessary
  cnMaxServices = 4096;

  { type
  TSvcA = array[0..cnMaxServices]
  of TEnumServiceStatus;
  PSvcA = ^TSvcA; }

var
  //
  // temp. use
  j: integer;

  //
  // service control
  // manager handle
  schm: SC_HANDLE;

  //
  // bytes needed for the
  // next buffer, if any
  nBytesNeeded,

  //
  // number of services
  nServices,

  //
  // pointer to the
  // next unread service entry
  nResumeHandle: Dword;

  //
  // service status array
  // ssa : PSvcA;
  ssa: Array of TEnumServiceStatus;
begin
  Result := false;

  // connect to the service
  // control manager
  schm := OpenSCManager(PChar(sMachine), nil, SC_MANAGER_ALL_ACCESS);

  // if successful...
  if (schm > 0) then
  begin
  nResumeHandle := 0;

  // New(ssa);

  EnumServicesStatus(schm, dwServiceType, dwServiceState, ssa[0], 0, nBytesNeeded, nServices, nResumeHandle);
  SetLength(ssa, (nBytesNeeded div SizeOf(TEnumServiceStatus) + 1));
  if not EnumServicesStatus(schm, dwServiceType, dwServiceState, ssa[0], nBytesNeeded, nBytesNeeded, nServices, nResumeHandle) then
  Exit;

  { EnumServicesStatus(
  schm,
  dwServiceType,
  dwServiceState,
  ssa[0],
  SizeOf(ssa)+1,
  nBytesNeeded,
  nServices,
  nResumeHandle); }

  //
  // assume that our initial array
  // was large enough to hold all
  // entries. add code to enumerate
  // if necessary.
  //

  for j := 0 to nServices - 1 do
  begin
    slServicesList.Add(StrPas(TEnumServiceStatus(ssa[j]).lpDisplayName));
    slServicesDisplayerNames.Add(StrPas(TEnumServiceStatus(ssa[j]).lpServiceName));
  end;

  Result := true;

  // Dispose(ssa);

  // close service control
  // manager handle
  CloseServiceHandle(schm);

  end;
end;



end.

